import {FC} from 'react';
import styled from 'styled-components';

const Base = styled('div')({
	borderRadius: '0.25rem',
	position: 'relative',
	padding: '1rem',
	boxSizing: 'border-box',
	'::after': {
		content: "''",
		position: 'absolute',
		top: 0,
		left: 0,
		width: '100%',
		height: '100%',
		boxSizing: 'border-box',
		borderRadius: 'inherit',
		pointerEvents: 'none',
		border: '1px solid',
	},
})

type Props = {
	className?: string,
}

const Card: FC<Props> = ({
	children,
	...etcProps
}) => {
	return (
		<Base
			{...etcProps}
		>
			{children}
		</Base>
	)
}

export default Card
