import {useEffect} from 'react';

const Timer = ({
	interval,
	onTick,
	resume = false,
	start,
}) => {
	useEffect(() => {
		let intervalHandler
		if (resume) {
			intervalHandler = setInterval(() => {
				onTick(Date.now())
			}, interval)
		}
		return () => {
			if (intervalHandler) {
				clearInterval(intervalHandler)
			}
		}
	}, [interval, resume])

	useEffect(() => {
		onTick(start)
	}, [start])

	return (
		<></>
	)
}

export default Timer
