import {render, screen} from '@testing-library/react'
import CreateRingtoneForm from '.'

describe('form for creating ringtones', () => {
	beforeEach(() => {
		render(
			<CreateRingtoneForm
				labels={{
					form: 'Create Ringtone',
					name: 'Name',
					data: 'Data',
					cta: 'Post',
				}}
			/>
		)
	})

	it('should render a form', () => {
		expect(screen.getByRole('form', { name: 'Create Ringtone' })).toBeInTheDocument()
	})

	it('should render a textbox for the ringtone name', () => {
		expect(screen.getByRole('textbox', { name: 'Name' })).toBeInTheDocument()
	})

	it('should render a textbox for the ringtone data', () => {
		expect(screen.getByRole('textbox', { name: 'Data' })).toBeInTheDocument()
	})

	it('should render a button for submitting the ringtone data', () => {
		expect(screen.getByRole('button', { name: 'Post' })).toBeInTheDocument()
	})
})
