import {GetServerSideProps, NextPage} from 'next'
import {useEffect, useState} from 'react';
import {models} from '@tonality/library-common'
import RingtoneClient from '../../modules/ringtone/client'

type Props = {
	user: models.User,
	composerRingtones: models.Ringtone[],
}

const MyCreateRingtonePage: NextPage<Props> = ({
	user,
	composerRingtones,
}) => {
	const [hydrated, setHydrated] = useState(false)
	const [ringtoneClient, setRingtoneClient] = useState<RingtoneClient>(null)

	useEffect(() => {
		setHydrated(true)
	}, [])

	useEffect(() => {
		setRingtoneClient(new RingtoneClient(process.env.NEXT_PUBLIC_API_BASE_URL))
	}, [hydrated])

	return (
		<div>
			Hello
		</div>
	)
}

export const getServerSideProps: GetServerSideProps = async () => {
	const user = {
		id: '00000000-0000-0000-0000-000000000000',
		name: 'TheoryOfNekomata',
		bio: '',
	}

	const composerRingtones = []

	return {
		props: {
			user,
			composerRingtones,
		},
	}
}

export default MyCreateRingtonePage
