let oscillator: OscillatorNode

export default class WaveOscillator {
	private readonly oscillators: Record<number, OscillatorNode> = {}

	constructor(private readonly audioContext: AudioContext, private readonly audioDestinationNode: AudioNode) {}

	private static getKeyFrequency(keyNumber: number) {
		return 440 * Math.pow(Math.pow(2, 1 / 12), keyNumber - 69)
	}

	start(keyNumber: number) {
		this.oscillators[keyNumber] = this.audioContext.createOscillator()
		this.oscillators[keyNumber].type = 'square'
		this.oscillators[keyNumber].frequency.value = WaveOscillator.getKeyFrequency(keyNumber)
		this.oscillators[keyNumber].connect(this.audioDestinationNode)
		try {
			this.oscillators[keyNumber].start()
		} catch {

		}
	}

	stop(keyNumber: number) {
		try {
			this.oscillators[keyNumber].stop()
		} catch {}
	}
}
