export type Duration = 1 | 2 | 4 | 8 | 16 | 32
export const ALLOWED_DURATIONS = [1, 2, 4, 8, 16, 32] as readonly Duration[]

export const toRawDuration = (duration: number, tempo: number) => {
	if (isNaN(tempo)) {
		throw new RangeError('Tempo should not be NaN.')
	}
	if (!isFinite(tempo)) {
		throw new RangeError('Tempo should be a finite value.')
	}
	if (tempo <= 0) {
		throw new RangeError('Tempo should be a positive value.')
	}
	return (4 / duration) * (60000 / tempo)
}
