import {parse, stringify, v4} from 'uuid';

function toString(this: Uuid) {
	return stringify(this)
}

function toBuffer(this: Uuid) {
	return Buffer.from(this)
}

const constructUuidBase = (bytes: any): UuidBuffer => {
	const uuidBase = Buffer.from(bytes)
	uuidBase.toString = toString.bind(uuidBase);
	const uuidBaseExtend = uuidBase as unknown as Record<string, unknown>
	uuidBaseExtend.toBuffer = toBuffer.bind(uuidBase)
	return uuidBase
}

export interface UuidBuffer extends Buffer {
	toBuffer?(): Buffer,
}

export default class Uuid extends Buffer {
	static new(): UuidBuffer {
		const raw = v4()
		const bytes = parse(raw) as Uint8Array
		return constructUuidBase(bytes)
	}

	static from(bytes: any): UuidBuffer {
		return constructUuidBase(bytes)
	}

	toString(): string {
		return stringify(this)
	}

	static parse(s: string): UuidBuffer {
		const bytes = parse(s) as Uint8Array
		return constructUuidBase(bytes)
	}
}
