import {PrismaClient as RealPrismaClient} from '@prisma/client';
import RingtoneService from './service';
import {models} from '@tonality/library-common';
import {container} from 'tsyringe';
import {MockPrismaRepository} from '../../utils/mocks';
import Uuid from '@tonality/library-uuid';
import globalBootstrap from '../../global'
import bootstrap from '.'

jest.mock('@prisma/client')
const PrismaClient = RealPrismaClient as jest.Mock

describe('ringtone service', () => {
	let ringtoneService: RingtoneService

	beforeAll(() => {
		globalBootstrap(container)
	})

	beforeAll(() => {
		bootstrap(container)
	})

	beforeEach(() => {
		PrismaClient.mockImplementationOnce(() => ({
			ringtone: new MockPrismaRepository<models.Ringtone>([], 'id'),
		}))
	})

	beforeEach(() => {
		ringtoneService = container.resolve('RingtoneService')
	})

	describe('retrieval of single ringtone', () => {
		it('should get from the repository', async () => {
			const prismaClient: RealPrismaClient = container.resolve('PrismaClient')
			console.log(prismaClient)
			const findUnique = jest.spyOn(prismaClient.ringtone, 'findUnique')
			await ringtoneService.get(Uuid.new())
			expect(findUnique).toBeCalled()
		})
	})
})
