import {FastifyPluginAsync} from 'fastify'
import {container} from 'tsyringe'
import RingtoneController from '../../../../modules/ringtone/controller'

const ringtones: FastifyPluginAsync = async (fastify): Promise<void> => {
	const ringtoneController = container.resolve<RingtoneController>('RingtoneController')
	fastify.get('/', ringtoneController.search)
}

export default ringtones
