import {FastifyReply, FastifyRequest} from 'fastify';

export interface ControllerResponse<T = unknown> {
	data: T
}

export interface PaginatedResponse<T> extends ControllerResponse<T[]> {
	skip: number,
	take: number,
}

export type Controller<ResponseMap extends Record<string, unknown> = Record<string, unknown>> = {
	[T in keyof ResponseMap]: (request: FastifyRequest, reply: FastifyReply) => Promise<ControllerResponse | void>
}
