type CreateArgs = { data: Record<string, any> }

type UpdateArgs = { data: Record<string, any>, where: Record<string, any> }

export class MockPrismaRepository<T extends Record<string, any> = Record<string, any>> {
	constructor(private data: T[], private readonly pkAttribute: string) {}

	async findMany() {
		return this.data
	}

	async findFirst() {
		return this.data[0]
	}

	async findUnique() {
		return this.data[0]
	}

	async create(args: CreateArgs) {
		return args.data
	}

	async update(args: UpdateArgs) {
		let updatedData: T | undefined
		this.data = this.data.map(d => {
			if (d[this.pkAttribute].toString() === args.where[this.pkAttribute].toString()) {
				return (updatedData = {
					...d,
					...args.data,
				} as T)
			}
			return d
		})
		if (updatedData) {
			return updatedData
		}
		return args.data
	}

	async delete() {}
}
